Skip to content

Creates a new invoice record that does not already exist.

Request

This method will auto-generate an ID and create a new invoice. If an ID is specified for the invoice, an error will be thrown.

Security
knox-authorizer
Path
tenantIdstringrequired

The id of the tenant being accessed.

Bodyapplication/jsonrequired

The invoice that you would like to be saved.

amount_paidnumber, (double)(Amount Paid)required

The amount paid on the invoice

amount_refundednumber, (double)(Amount Refunded)required

The amount refunded on the invoice

amount_written_offnumber, (double)(Amount Written Off)required

The amount written off on the invoice

balance_duenumber, (double)(Balance Due)required

The balance due on the invoice

base_currency_codestring, = 3 characters(Base Currency Code)

The base currency for transactions business unit

base_currency_symbolstring(Base Currency Symbol)

The base symbol for the transactions business unit

batch_idstring(Batch)

The batch this transaction belongs to

bill_to_contact_idstring(Bill To Contact)required

The person being billed for this invoice

bill_to_organization_idstring(Bill To Organization)required

The organization being billed for this invoice

bill_to_typestring(Bill To Type)required

The type of invoice

Enum:"contact""organization"
billing_addressobject(Address)

A complete address

business_unit_idstring(Business Unit)required

The business unit this transaction belongs to

cancellation_idstring(Cancellation)

The order cancellation tied to this transaction

currency_codestring, = 3 characters(Currency Code)

The currency code in use

Enum:"AED""AFN""ALL""AMD""ANG""AOA""ARS""AUD""AWG""AZN"
currency_symbolstring(Currency Symbol)

The currency symbol

custom_field_valuesArray of objects(Custom Field Values)
custom_metadataobject(Custom Metadata)

Custom metadata that can be used by custom order generation processes for hyper-customized order & invoice forms

datestring, (date)(Date)

The date of the transaction

date_duestring, (date)(Date Due)required

The date the invoice is due

exchange_ratenumber, (double)(Exchange Rate)

The exchange rate, if applicable

idstring(ID)^[\w|-]+$required

The unique, string identifier of this invoice

legacy_balance_duenumber, (double)(Legacy Balance Due)

The balance due from the legacy system

line_itemsArray of objects, non-emptyrequired
memostring(Memo)

Memo/description of the transaction

notesstring(Notes)

Notes fro the transaction

numberinteger(Number)required

The transaction number

order_idstring(Order)

The order tied to this transaction

parent_invoice_idstring(Parent Invoice)

A parent invoice for this invoice

payment_terms_idstring(Payment Terms)

The invoice terms being applied to this invoice

pro_formaboolean(Pro Forma)

Whether or not this is a pro forma invoice

purchase_order_numberstring(Purchase Order Number)

The purchase order number

regenerated_invoice_idstring(Regenerated Invoice)

For legacy invoices that needed to be regenerated, this is the ID of that generated invoice

regeneration_errorstring(Regeneration Error)

If an error occurs during regeneration, it is logged here

return_idstring(Return)

The return tied to this transaction

send_email_to_billing_contactboolean(Send Email To Billing Contact)

If true, when email is processed, an email will be sent to the billing contact

sharing_secretstring(Sharing Secret)

Hash to be used as salt when sharing invoices publicly, preventing users from accessing invoices unless they have been given the link explicitly

statusstring(Status)required

The status of the invoice

Enum:"cancelled""open""paid""void""written off"
sys_bulk_load_atstring(Sys Bulk Load At)

If this record was loaded via bulk, the timestamp when the record was processed

sys_bulk_load_idstring(Sys Bulk Load)

If this record was loaded via bulk, the ID of the bulk load process

sys_bulk_load_pkstring(Sys Bulk Load Pk)

If this record was loaded via bulk, the tenant and key of the bulk load process used as a partition key

sys_bulk_load_record_nonumber, (float)(Sys Bulk Load Record No)

If this record was loaded via bulk, the record number in the source file

sys_bulk_load_source_filestring(Sys Bulk Load Source File)

If this record was loaded via bulk, the source file

sys_calculated_field_errorstring(Sys Calculated Field Error)

The error associated with the calculated field

sys_calculated_field_errorsArray of objects
sys_configuration_snapshot_idstring(Sys Configuration Snapshot)

If a snapshot was restored/applies to this record, the ID of the snapshot

sys_created_atstring, (date-time)(Sys Created At)required

The date/time that this record was created, expressed in ISO-8601 date format

sys_created_by_idstring(Sys Created By)required

The ID of the user that created this record

sys_deleted_by_idstring(Sys Deleted By)

The ID of the user that deleted (or last tried to delete) this object

sys_directivestring(Sys Directive)

Means for passing directive information into an object processing logic

sys_external_idstring(Sys External)

The ID that a record has from an external system or data import

sys_has_files_in_s3boolean(Sys Has Files In S3)

If true, this record has files in S3. If false, it doesnt, so no need to hit S3 upon deletion

sys_last_bulk_data_operation_idstring(Sys Last Bulk Data Operation)

If this record was last touched by a bulk data operation, the ID of that operation

sys_last_bulk_data_operation_sys_versionstring(Sys Last Bulk Data Operation Sys Version)

If this record was last touched by a bulk data operation, the sys_version at the time of that operation

sys_last_modified_atstring, (date-time)(Sys Last Modified At)required

The date/time that this record record was last modified, expressed in ISO-8601 date format

sys_last_modified_by_idstring(Sys Last Modified By)required

The ID of the user that last modified this record

sys_last_security_contextobject(Sys Last Security Context)

The security context of the last insert, modify, or delete performed on this item

sys_lockedboolean(Sys Locked)

If set, this record is locked and cannot be changed via the API

sys_search_composite_keystring(Sys Search Composite Key)

Internal use

sys_snapshot_base_versionnumber, (float)(Sys Snapshot Base Version)

The version to use as a base when creating a configuration snapshot; if not set, 1 is used. Helpful when creating a sandbox

sys_versionnumber, (float)(Sys Version)

A number representing the version of this record in the database

template_idstring(Template)

The template this invoice is using for printing/emailing

totalnumber, (double)(Total)required

The transaction total

total_in_base_currencynumber, (double)(Total In Base Currency)required

The total of the transaction, in the base currency of the business unit.

typestring(Type)

The type of invoice

uses_v2_apiboolean(Uses V2 Api)

This invoice was processed using the v2 sync, as opposed to legacy step functions

workflow_execution_idstring(Workflow Execution)

The ID of the state machine execution used to create this transaction

curl -i -X POST \
  'https://docs.api.rhythmsoftware.com/_mock/apis/collect/collect-v1/invoices/{tenantId}' \
  -H 'Authorization: Bearer <YOUR_JWT_HERE>' \
  -H 'Content-Type: application/json' \
  -d '{
    "amount_paid": 0.1,
    "amount_refunded": 0.1,
    "amount_written_off": 0.1,
    "balance_due": 0.1,
    "base_currency_code": "str",
    "base_currency_symbol": "string",
    "batch_id": "string",
    "bill_to_contact_id": "string",
    "bill_to_organization_id": "string",
    "bill_to_type": "contact",
    "billing_address": {
      "city": "string",
      "country": "string",
      "country_name": "string",
      "county": "string",
      "latitude": 0.1,
      "line1": "string",
      "line2": "string",
      "line3": "string",
      "longitude": 0.1,
      "postal_code": "string",
      "state": "string",
      "time_zone_id": "string"
    },
    "business_unit_id": "string",
    "cancellation_id": "string",
    "currency_code": "AED",
    "currency_symbol": "string",
    "custom_field_values": [
      {
        "boolean_value": true,
        "custom_field_id": "string",
        "file_url_value": "string",
        "list_value": [
          "string"
        ],
        "numeric_value": 0.1,
        "string_value": "string",
        "table_value": [
          {}
        ]
      }
    ],
    "custom_metadata": {},
    "date": "2019-08-24",
    "date_due": "2019-08-24",
    "exchange_rate": 0.1,
    "id": "string",
    "legacy_balance_due": 0.1,
    "line_items": [
      {
        "amount_paid": 0.1,
        "amount_refunded": 0.1,
        "amount_to_pay_upon_creation": 0.1,
        "amount_written_off": 0.1,
        "balance_due": 0.1,
        "bundled_product_1": {
          "amount": 0.1,
          "product_id": "string",
          "product_type": "string"
        },
        "bundled_product_2": {
          "amount": 0.1,
          "product_id": "string",
          "product_type": "string"
        },
        "description": "string",
        "has_inline_bundled_products": true,
        "inline_bundled_products": [
          {
            "amount": 0.1,
            "product_id": "string",
            "product_type": "string"
          }
        ],
        "invoice_line_item_id": "string",
        "legacy_ar_gl_account": "string",
        "legacy_balance_due": 0.1,
        "legacy_project": "string",
        "legacy_revenue_account": "string",
        "optional": true,
        "order_line_item_id": "string",
        "original_total": 0.1,
        "original_total_in_base_currency": 0.1,
        "primary_product_total": 0.1,
        "product_id": "string",
        "product_type": "string",
        "quantity": 0.1,
        "related_transactions": [
          {
            "amount": 0.1,
            "date": "2019-08-24T14:15:22Z",
            "transaction_id": "string",
            "transaction_line_item_id": "string",
            "transaction_number": 0.1,
            "type": "cancellation"
          }
        ],
        "status": "cancelled",
        "total": 0.1,
        "total_in_base_currency": 0.1,
        "unit_price": 0.1
      }
    ],
    "memo": "string",
    "notes": "string",
    "number": 0,
    "order_id": "string",
    "parent_invoice_id": "string",
    "payment_terms_id": "string",
    "pro_forma": true,
    "purchase_order_number": "string",
    "regenerated_invoice_id": "string",
    "regeneration_error": "string",
    "return_id": "string",
    "send_email_to_billing_contact": true,
    "sharing_secret": "string",
    "status": "cancelled",
    "sys_bulk_load_at": "string",
    "sys_bulk_load_id": "string",
    "sys_bulk_load_pk": "string",
    "sys_bulk_load_record_no": 0.1,
    "sys_bulk_load_source_file": "string",
    "sys_calculated_field_error": "string",
    "sys_calculated_field_errors": [
      {
        "error": "string",
        "field": "string"
      }
    ],
    "sys_configuration_snapshot_id": "string",
    "sys_created_at": "2019-08-24T14:15:22Z",
    "sys_created_by_id": "string",
    "sys_deleted_by_id": "string",
    "sys_directive": "string",
    "sys_external_id": "string",
    "sys_has_files_in_s3": true,
    "sys_last_bulk_data_operation_id": "string",
    "sys_last_bulk_data_operation_sys_version": "string",
    "sys_last_modified_at": "2019-08-24T14:15:22Z",
    "sys_last_modified_by_id": "string",
    "sys_last_security_context": {},
    "sys_locked": true,
    "sys_search_composite_key": "string",
    "sys_snapshot_base_version": 0.1,
    "sys_version": 0.1,
    "template_id": "string",
    "total": 0.1,
    "total_in_base_currency": 0.1,
    "type": "string",
    "uses_v2_api": true,
    "workflow_execution_id": "string"
  }'

Responses

The operation completed successfully

Headers
Access-Control-Allow-Headersstring
Access-Control-Allow-Methodsstring
Access-Control-Allow-Originstring
Bodyapplication/json
executionArnstring(Executionarn)required

The arn of the execution

notification_channelstring(Notification Channel)

The id of the channel where progress updates will be posted

notification_publishKeystring(Notification Publishkey)

The publish key for the channel where progress updates will be posted

notification_subscribeKeystring(Notification Subscribekey)

The subscribe key for the channel where progress updates will be posted

start_datestring, (date-time)(Start Date)

The start date of the execution

Response
{ "executionArn": "string", "notification_channel": "string", "notification_publishKey": "string", "notification_subscribeKey": "string", "start_date": "2019-08-24T14:15:22Z" }